diff -urN ../VisualBoyAdvance-1.7.2/src/arm-new.h ./src/arm-new.h
--- ../VisualBoyAdvance-1.7.2/src/arm-new.h	2004-05-13 22:57:11 +0900
+++ ./src/arm-new.h	2006-08-25 22:30:08 +0900
@@ -2260,18 +2473,23 @@
       // MUL Rd, Rm, Rs
       int dest = (opcode >> 16) & 0x0F;
       int mult = (opcode & 0x0F);
+      clockTicks = 1; 
       u32 rs = reg[(opcode >> 8) & 0x0F].I;
       reg[dest].I = reg[mult].I * rs;
       if(((s32)rs)<0)
-        rs = ~rs;
+         rs = ~rs;
       if((rs & 0xFFFFFF00) == 0)
-        clockTicks += 2;
+        clockTicks += 0;
       else if ((rs & 0xFFFF0000) == 0)
-        clockTicks += 3;
+        clockTicks += 1;
       else if ((rs & 0xFF000000) == 0)
-        clockTicks += 4;
+        clockTicks += 2;
       else
-        clockTicks += 5;
+        clockTicks += 3;
+      if (!busPrefetchCount)
+        busPrefetchCount = ((++busPrefetchCount)<<clockTicks) - 1;
+      clockTicks += codeTicksAccess32(armNextPC) + 1;
+
     }
     break;
   case 0x019:
@@ -2279,6 +2497,7 @@
       // MULS Rd, Rm, Rs
       int dest = (opcode >> 16) & 0x0F;
       int mult = (opcode & 0x0F);
+      clockTicks = 1;
       u32 rs = reg[(opcode >> 8) & 0x0F].I;
       reg[dest].I = reg[mult].I * rs;
       N_FLAG = (reg[dest].I & 0x80000000) ? true : false;
@@ -2286,24 +2505,30 @@
       if(((s32)rs)<0)
         rs = ~rs;
       if((rs & 0xFFFFFF00) == 0)
-        clockTicks += 2;
+        clockTicks += 0;
       else if ((rs & 0xFFFF0000) == 0)
-        clockTicks += 3;
+        clockTicks += 1;
       else if ((rs & 0xFF000000) == 0)
-        clockTicks += 4;
+        clockTicks += 2;
       else
-        clockTicks += 5;
+        clockTicks += 3;
+      if (!busPrefetchCount)
+        busPrefetchCount = ((++busPrefetchCount)<<clockTicks) - 1;
+      clockTicks += codeTicksAccess32(armNextPC) + 1;
     }
     break;
   case 0x00b:
   case 0x02b:
     {
       // STRH Rd, [Rn], -Rm
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = reg[opcode & 0x0F].I;
-      clockTicks += 4 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
       CPUWriteHalfWord(address, reg[dest].W.W0);
       address -= offset;
       reg[base].I = address;
@@ -2313,11 +2538,14 @@
   case 0x06b:
     {
       // STRH Rd, [Rn], #-offset
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = (opcode & 0x0F) | ((opcode >> 4) & 0xF0);
-      clockTicks += 4 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address)
+          + codeTicksAccess32(armNextPC);
       CPUWriteHalfWord(address, reg[dest].W.W0);
       address -= offset;
       reg[base].I = address;
@@ -2327,11 +2555,14 @@
   case 0x0ab:
     {
       // STRH Rd, [Rn], Rm
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = reg[opcode & 0x0F].I;
-      clockTicks += 4 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
       CPUWriteHalfWord(address, reg[dest].W.W0);
       address += offset;
       reg[base].I = address;
@@ -2341,11 +2572,14 @@
   case 0x0eb:
     {
       // STRH Rd, [Rn], #offset
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I;
       int offset = (opcode & 0x0F) | ((opcode >> 4) & 0xF0);
-      clockTicks += 4 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
       CPUWriteHalfWord(address, reg[dest].W.W0);
       address += offset;
       reg[base].I = address;
@@ -2354,20 +2588,26 @@
   case 0x10b:
     {
       // STRH Rd, [Rn, -Rm]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - reg[opcode & 0x0F].I;
-      clockTicks += 4 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
       CPUWriteHalfWord(address, reg[dest].W.W0);
     }
     break;
   case 0x12b:
     {
       // STRH Rd, [Rn, -Rm]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - reg[opcode & 0x0F].I;
-      clockTicks += 4 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
       CPUWriteHalfWord(address, reg[dest].W.W0);
       reg[base].I = address;
     }
@@ -2375,20 +2615,26 @@
   case 0x14b:
     {
       // STRH Rd, [Rn, -#offset]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 4 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
       CPUWriteHalfWord(address, reg[dest].W.W0);
     }
     break;
   case 0x16b:
     {
       // STRH Rd, [Rn, -#offset]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I - ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 4 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
       CPUWriteHalfWord(address, reg[dest].W.W0);
       reg[base].I = address;
     }
@@ -2396,20 +2642,26 @@
   case 0x18b:
     {
       // STRH Rd, [Rn, Rm]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + reg[opcode & 0x0F].I;
-      clockTicks += 4 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
       CPUWriteHalfWord(address, reg[dest].W.W0);
     }
     break;
   case 0x1ab:
     {
       // STRH Rd, [Rn, Rm]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + reg[opcode & 0x0F].I;
-      clockTicks += 4 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
       CPUWriteHalfWord(address, reg[dest].W.W0);
       reg[base].I = address;
     }
@@ -2417,20 +2669,26 @@
   case 0x1cb:
     {
       // STRH Rd, [Rn, #offset]
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 4 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
       CPUWriteHalfWord(address, reg[dest].W.W0);
     }
     break;
   case 0x1eb:
     {
       // STRH Rd, [Rn, #offset]!
+      if (!busPrefetchCount)
+        busPrefetch = busPrefetchEnable;
       int base = (opcode >> 16) & 0x0F;
       int dest = (opcode >> 12) & 0x0F;
       u32 address = reg[base].I + ((opcode & 0x0F)|((opcode>>4)&0xF0));
-      clockTicks += 4 + CPUUpdateTicksAccess16(address);
+      clockTicks = 2 + dataTicksAccess16(address) +
+          codeTicksAccess32(armNextPC);
       CPUWriteHalfWord(address, reg[dest].W.W0);
       reg[base].I = address;
     }
